<?php

namespace App\Http\Controllers;

use App\Models\User;
use App\Http\Requests;

use App\Models\Protocolo;
use Illuminate\Http\Request;
use App\Mail\NotificacaoMail;
use App\Models\Acompanhamento;
use Illuminate\Support\Carbon;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;
use App\Notifications\TelegramNotification;

class AcompanhamentoController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }


    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\View\View
     */
    public function index(Request $request)
    {
        $keyword = $request->get('search');
        $perPage = 25;

        if (!empty($keyword)) {
            $acompanhamento = Acompanhamento::where('descricao', 'LIKE', "%$keyword%")
                ->orWhere('idProtocolo', 'LIKE', "%$keyword%")
                ->orWhere('idUsuario', 'LIKE', "%$keyword%")
                ->orWhere('idSolicitante', 'LIKE', "%$keyword%")
                ->latest()->paginate($perPage);
        } else {
            $acompanhamento = Acompanhamento::latest()->paginate($perPage);
        }

        return view('acompanhamento.index', compact('acompanhamento'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\View\View
     */
    public function create()
    {
        return view('acompanhamento.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     *
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function store(Request $request)
    {
        $this->validate($request, [
			'descricao' => 'required'
		]);

        $requestData = $request->all();

        if(Acompanhamento::create($requestData) != null){
            $nome = User::findOrFail($requestData['idUsuario'])->name;

            $protocolo = Protocolo::findOrFail($requestData['idProtocolo']);
            $protocolo->status = 'respondida';
            $protocolo->update();

            $user = User::findOrFail($protocolo->idUser);
            if($user->notificarEmail){
                //Mail::send(new NotificacaoMail($user, 'solicitacaoRespondida'));
            }

            if($user->notificarEmail){
                $user->notify(new TelegramNotification(TelegramNotification::SOLICITACAO_RESPONDIDA));
            }

            return "<b>Por ".$nome." em ".Carbon::now()->format("d/m/Y H:i")."</b><br><p>".$requestData['descricao']."</p>";
        }else{
            return "<p>A resposta não pode ser enviada devido a problemas técnicos. Tente novamente mais tarde.</p>";
        }

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     *
     * @return \Illuminate\View\View
     */
    public function show($id)
    {
        $acompanhamento = Acompanhamento::findOrFail($id);

        return view('acompanhamento.show', compact('acompanhamento'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     *
     * @return \Illuminate\View\View
     */
    public function edit($id)
    {
        $acompanhamento = Acompanhamento::findOrFail($id);

        return view('acompanhamento.edit', compact('acompanhamento'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param  int  $id
     *
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
			'descricao' => 'required'
		]);
        $requestData = $request->all();

        $acompanhamento = Acompanhamento::findOrFail($id);
        $acompanhamento->update($requestData);

        return redirect('acompanhamento')->with('flash_message', 'Acompanhamento updated!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     *
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function destroy($id)
    {
        Acompanhamento::destroy($id);

        return redirect('acompanhamento')->with('flash_message', 'Acompanhamento deleted!');
    }

    public function listarAcompanhamentos($idProtocolo){
        $acompanhamentos = Acompanhamento::all()->where('idProtocolo', '=', $idProtocolo);
        $nivel = [];

        foreach($acompanhamentos as $indice => $acompanhamento){
            $usuario = User::findOrFail($acompanhamento->idUsuario);
            $acompanhamento->idUsuario = $usuario->name;
            $nivel[$indice] = $usuario->nivel;        }

        return ["acompanhamentos" => $acompanhamentos, "nivel" => $nivel];
    }
}
